﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FestoDebugger.Service
{
    [Serializable]
    public class Singleton<T> where T : class, new()
    {
        private static readonly Lazy<T> lazy =
                                        new Lazy<T>(() => new T(), true);
        public static T Instance => lazy.Value;
    } 
}
